import 'option.dart';
import 'terminal.dart';

final Terminal _terminal = const Terminal();

class Prompter{
  bool askBinary(String prompt) {
    final input = _ask('$prompt (y/n)?',[]);
    if (['Y','y','Yes','yes','YES'].contains(input)) {
      return true;
    } else if (['N','n','No','no','NO'].contains(input)) {
      return false;
    } else {
      return askBinary(prompt);
    }
  }

  askMultiple(String prompt, List<Option> options){
    final input = _ask(prompt, options);
    try {
      return options[int.parse(input)].value;
    } catch (err) {
      return askMultiple(prompt,options);
    }
  }

  int askNumValue(String prompt){
    final input = _ask(prompt,[]);
    int value = int.tryParse(input);
    if (value == null) {
      value = askNumValue(prompt);
    }
    return value;
  }

  String _ask(String prompt, List<Option> options) {
    _terminal.clearScreen();
    _terminal.printPrompt(prompt);
    _terminal.printOptions(options);

    return _terminal.collectInput();
  }
}